{% extends "siswa/userbase.html.twig" %}
{% import "macros/form.html.twig" as f %}

{% block body %}

    {% block moreCss %}
    {% endblock %}
    {% embed 'siswa/secondaryBar.html.twig' %}
        {% block title %}
            {{ data.title }}
        {% endblock %}



    {% endembed %}

    {#    Tagihan#}
    <section class="mt-1" id="content">
        <div id="bottomBar" class="flex-fill">
            {% if startedAt is not null and isEnded == false %}
                <p id="countdown_p" class="mb-0 text-center p-2 f08 w-100"
                   style="border-radius: 10px; border: 1px solid var(--primaryColor)">Sisa Waktu: <span
                            class="countdown t-primary"
                    ></span></p>
            {% endif %}
            <div class="d-flex pt-3  w-100 align-items-center">
                <div id="numberInPage" class="scrolling-wrapper mr-1">
                </div>

            </div>
        </div>


        <img src="{{ data.banner ?? asset('images/common/tryout/tryout.png') }}" class="w-100">

    </section>

    <section class="container-fluid mt-3">
        <div class="d-flex align-items-center  mb-2">
            <i class="mdi mdi-group mr-2 t-primary f14"></i>
            <p class="mb-0">{{ data.registrant.toArray|length }} Peserta Berpartisipasi</p>
        </div>
        {% if data.startDay is not  null %}
            <div class="d-flex align-items-center mb-3">
                <i class="mdi mdi-date-range mr-2 t-primary f14"></i>
                <p class="mb-0">{{ data.startDay ? data.startDay|date("d M Y") : '' }}  {{ data.finalDay ? ' - ' ~ data.finalDay|date("d M Y") : '' }}</p>
            </div>
        {% endif %}
    </section>

    <hr>

    <nav class="container-fluid">
        <div class="nav w-100 d-flex" id="nav-tab" role="tablist">
            <a class="nav-item nav-link active text-center d-block flex-grow-1 tab-pils"
               id="nav-home-tab"
               data-toggle="tab" href="#panduan" role="tab" aria-controls="rapor"
               aria-selected="true">Panduan Tryout</a>
        </div>
    </nav>

    <div class="tab-content" id="nav-tabContent">
        <div class="tab-pane fade show active" id="panduan" role="tabpanel"
             aria-labelledby="panduan-tab">
            <section class="mt-3 container-fluid d-none" id="direction">
                {{ (data.direction|replace({'Powered by' : '', 'Froala Editor' : ''}))|raw }}


            </section>

        </div>

    </div>


    <div class="space-50h"></div>

    <div class="modal fade" id="sendWarning" tabindex="-1" role="dialog" aria-labelledby="allSoal"
         aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">

                <div class="modal-body">
                    <a data-dismiss="modal" aria-label="Close"><i class="mdi mdi-close f14 d-block text-right"></i></a>

                    <p class="f18 text-center mt-3">Peringatan !</p>
                    <p style="border-radius: 50px; text-align: center; border: 1px solid var(--primaryColor); color: var(--primaryColor); "
                       class="f16 "><span class="countdown"></span></p>
                    <div class="mt-1">
                        <div id="numberInModal" class="text-center"> Kamu tidak bisa megerjakan try out ini setelah
                            mengirimkannya, kamu yakin mau mengirimkan semua jawaban?
                        </div>
                    </div>

                    <div class="modal-footer">
                        <a id="sendNow" class="bt-accent w-100 f10">Ya, kirim sekarang.</a>
                    </div>
                </div>
            </div>
        </div>
    </div>

{% endblock %}

{% block JSMore %}
    <script src="{{ asset('js/formatter.js') }}"></script>
    <script>
        let asuTime = new Date();
        let notAnswered = [];
        let interValCountDown;
        let timeOut = false;
        $(document).ready(function () {
            {% if startedAt is not null and isEnded == false %}

            asuTime = stringToDate("{{ startedAt }}");

            interValCountDown = setInterval(function () {
                makeTimer({{ data.estimatedTime }});
            }, 1000);
            {% endif %}
        });

        function makeTimer(asu) {
            endTime = new Date(asuTime.getTime() + (asu * 60000));


            endTime = (Date.parse(endTime) / 1000);


            var now = new Date();
            now = (Date.parse(now) / 1000);

            var timeLeft = endTime - now;

            var days = Math.floor(timeLeft / 86400);
            var hours = Math.floor((timeLeft - (days * 86400)) / 3600);
            var minutes = Math.floor((timeLeft - (days * 86400) - (hours * 3600)) / 60);
            var seconds = Math.floor((timeLeft - (days * 86400) - (hours * 3600) - (minutes * 60)));
            console.log("days", days)
            console.log("hours", hours)
            console.log("minutes", minutes)
            console.log("seconds", seconds)
            if ((isNaN(hours) && isNaN(minutes) && isNaN(minutes) && isNaN(seconds)) || days < 0) {
                timeOut = true;
                $("span.countdown").html("-");
                $("a#finishSend").removeAttr("class");
                $("a#finishSend").attr("class", "bt-disabled m-1 f10 d-block w-100");
                $("a#startTryout").removeAttr("class");
                $("a#startTryout").attr("class", "bt-disabled m-1 f10 d-block w-100");
                alert("Waktu Habis");
                clearInterval(interValCountDown);
                {#window.location = "{{ path('history-tryout') }}"#}
            } else {
                if (hours < "10") {
                    hours = "0" + hours;
                }
                if (minutes < "10") {
                    minutes = "0" + minutes;
                }
                if (seconds < "10") {
                    seconds = "0" + seconds;
                }


                $("span.countdown").html(hours + ":" + minutes + ":" + seconds);
            }

        }
    </script>
    <script>
        $(document).ready(function () {
            $("p[data-f-id='pbf']").remove();
            $("#direction").removeClass("d-none");
        });

        function finishTryOut(data) {
            window.location.reload();
        }

        $(document).on('click', 'a#sendNow', function (e) {
            e.preventDefault();
            var reg = $("#finishSend").data("rg");
            let uri = "{{ path("end_tryout_session", {reg :"nest"}) }}";
            uri = uri.replace("nest", reg);
            $("#sendWarning").modal('hide');
            ajaxCall("finishTryOut", uri, "POST", true);
        });

        function fetchData(data) {
            console.log("DATAAAA ", data);
            let startLink = "";
            data.forEach(function (data, key) {
                $("#nav-tab").append('<a class="nav-item nav-link flex-grow-1 tab-pils d-block" id="nav-profile-tab" data-toggle="tab"\n' +
                    '               href="#' + data['name'].replace(" ", "_") + '" role="tab" aria-controls="quiz" aria-selected="false">' + data['name'] + '</a>');
                let contentHtml = '';
                let prevIsDone = true;
                data['tryOutSubject'].forEach(function (s, key) {
                    let linkAction = "{{ path('mengerjakanSoal', {cat : 0, reg:'nest'}) }}";
                    linkAction = linkAction.replace("0", s['id']);
                    linkAction = linkAction.replace("nest", s['tryout']['registrant'][0]['id']);
                    if (key === 0 && !data['expired']) {
                        $("#direction").append(' <div class="fixed-bottom p-2 bg-white">\n' +
                            '                    <div class="d-flex justify-content-between align-items-center flex-column">\n' +
                            '                        <a id="startTryout" ' + (s['tryout']['registrant'][0]['isEnded'] || timeOut ? 'class="bt-disabled m-1 f10 d-block w-100"' : 'class="bt-primary m-1 f10 d-block w-100" id="goto"') + ' >\n' +
                            '                            Mulai Tryout\n' +
                            '                        </a>\n' +
                            '                    </div>\n' +
                            '                </div>');
                    }
                    if (data['expired']) {
                        $("#direction").append(' <div class="fixed-bottom p-2 bg-white">\n' +
                            '                    <div class="d-flex justify-content-between align-items-center flex-column">\n' +
                            '                        <a class="bt-accent m-1 f10 d-block w-100" >\n' +
                            '                            Masa aktif berakhir\n' +
                            '                        </a>\n' +
                            '                    </div>\n' +
                            '                </div>');
                    }
                    if (s['tryoutAnswer'].length > 0 && s['tryoutAnswer'][1]['isEnded'] && !timeOut) {
                        prevIsDone = false;
                    }
                    if (prevIsDone) {
                        startLink = linkAction;
                    }
                    contentHtml += '            <a class="d-block t-black" href="' + (prevIsDone ? linkAction : '') + '">\n' +
                        '                <div class="gen-card p-3" ' + (prevIsDone ? "" : " style='background-color: var(--grey);' ") + '>\n' +
                        '                    <div class="d-flex ">\n' +
                        '                        <img src="' + s['icon'] + '"\n' +
                        '                             style="border-radius: 15px; height: 4em; width: 4em; object-fit: cover" class="mr-3">\n' +
                        '                        <div class="flex-grow-1">\n' +
                        '                            <p class="font-weight-bold mb-0">' + s['subject']['name'] + '</p>\n' +
                        '                            <div class="d-flex align-items-center">\n' +
                        '                                <i class="mdi mdi-assignment f14 mr-2 t-primary"></i>\n' +
                        '                                <p class="mb-0 text-black-50">' + s['quizNumber'] + ' Soal</p>\n' +
                        '                            </div>\n' +
                        '                            <div class="d-flex align-items-center">\n' +
                        '                                <i class="mdi mdi-access-time f14 mr-2 t-primary"></i>\n' +
                        '                                <p class="mb-0 text-black-50">' + s['duration'] + ' Menit</p>\n' +
                        '                            </div>\n' +
                        '                        </div>\n' +
                        '                        <i class="mdi mdi-chevron-right f14"></i>\n' +
                        '                    </div>\n' +
                        '                </div>\n' +
                        '            </a>\n' +
                        (data['expired'] ? '' :
                            '            <div class="fixed-bottom p-2 bg-white">\n' +
                            '                <div class="d-flex justify-content-between align-items-center flex-column">\n' +
                            '                    <a id="finishSend" data-RG="' + s['tryout']['registrant'][0]['id'] + '" '
                            + ((s['tryoutAnswer'].length > 0 && s['tryoutAnswer'][0]['isEnded']) || timeOut ? 'class="bt-disabled m-1 f10 d-block w-100"' :
                            'class="bt-primary m-1 f10 d-block w-100"  data-toggle="modal" data-target="#sendWarning"') +
                            ' >\n' +
                            '                        Selesai dan Kirim\n' +
                            '                    </a>\n' +
                            '                </div>\n' +
                            '            </div>\n');
                    prevIsDone = ((s['tryout']['isStrict'] && (s['quizNumber'] === s['tryoutAnswer'].length)) || s['tryout']['isStrict'] === false);
                    if (s['tryoutAnswer'].length > 1 && s['tryoutAnswer'][1]['isEnded']) {
                        prevIsDone = true;
                    }

                });
                console.log("prevIsDone", prevIsDone);

                $("#nav-tabContent").append('<div class="tab-pane fade " id="' + data['name'].replace(" ", "_") + '" role="tabpanel"\n' +
                    '         aria-labelledby="tka-tab">\n' +
                    '\n' +
                    '        <section class="mt-3 container-fluid">\n' +

                    contentHtml +


                    '        </section>\n' +
                    '    </div>');
            });
            $("#goto").attr("href", startLink);
        }

    </script>

    {{ f.ajaxCall("fetchData", path("get_tab_menu_work_tryout_api", {cat : data.id, reg : reg}), "GET") }}

{% endblock %}